;------------------------------------------------------------------------------
;This function will replace spaces or all text between dubblequotesin the commandline with zerobytes
;input:
;  none
;output: EAX: amount of items in commandline
;------------------------------------------------------------------------------ `
if used processCommandline
processCommandline:
call getCommandLine

xchg peax,pdword [pesp]
push peax
end if

;------------------------------------------------------------------------------
;This function will replace spaces or all text between dubblequotes with zerobytes
;input:
;  1: string to modify  (on Windows : UTF-16, on Linux: UTF-8)
;output: EAX: amount of items in string
;------------------------------------------------------------------------------
if used splitCommandLine | used processCommandline
splitCommandLine:
call denter

mov peax,pdword [pebp+psize*2]

xor ecx,ecx
inc ecx ;there is always one item!
mov pesi,peax
xor edx,edx ;set of bits. if bit
;                         0x1 is set, there is a string between quotes
;                         0x2 is set, the next character is escaped

scanCommandLine:
  mov dl,dh
  if used isLin
    lodsb
    test al,al
    jz endScanCommanLine
  else
    lodsw
    test ax,ax
    jz endScanCommanLine
  end if
  
  test edx,1
  jnz checkEndOfString__scanCommandLine

  if used isLin
    cmp al,' '
  else
    cmp ax,' '
  end if
  je foundNewItem__scanCommandLine

  if used isLin
    cmp al,'"'
  else
    cmp ax,'"'
  end if
  jne scanCommandLine
  
  or dh,0x1 ;add flag
  jmp foundNewItem__scanCommandLine

checkEndOfString__scanCommandLine:
  ;set on dh the new flags where the flag 0x2 is removed
  mov dh,0x2
  and dh,dl
  xor dh,dl

  if used isLin
    cmp al,'\'  ;escape sign
  else
    cmp ax,'\' ;escape sign
  end if
  jne notEscapeSign__scanCommandLine

    test dl,0x2
    jnz scanCommandLine

    or dh,0x2 ;add flag
    jmp scanCommandLine

notEscapeSign__scanCommandLine:
  if used isLin
    cmp al,'"'  ;escape sign
  else
    cmp ax,'"' ;escape sign
  end if
  jne scanCommandLine

  test dl,0x2
  jnz scanCommandLine
  
  xor dh,0x1 ;remove flag

foundNewItem__scanCommandLine:
  inc ecx ;increment te amount of items in the commandline
  if used isLin
    mov byte [pesi-1],0
  else
    mov word [pesi-2],0
  end if

  jmp scanCommandLine

endScanCommanLine:
mov peax, pecx ;the amount of items in commandline

call dleave
ret psize
end if