
;TV's server version 3.20
;Copyright (c) 2014 - 2022, Tycho Veltmeijer.
;All rights reserved.

;------------------------------------------------------------------------------
;This function will call StartListening() from the first binded protocol with a new created Clientsession
;------------------------------------------------------------------------------
callStartListening:
StartProc 1 ;set param sess on stack
call denter
MakeStack

recallStartListening:
;find internal ListenSession
push pdword [pebp+psize*2] ;name (lsess)
push [listenSessions]      ;collectiom
call GetIndexedDwordItem
mov pesi,peax
mov peax,pdword [peax]     ;BindedTohandle

;get first psess of binded protocols
push 1
push peax
call GetDwordItem
mov pebx,peax              ;set psess on (R/E)BX

;get internal protocol session
push peax
call getInternalProtocolStructure
test eax,eax
jz errGetInternalProtocolStructure

;get modstruct
if used is32
  mov pedi,pdword [peax+psize*4]
else
  mov r12,pdword [peax+psize*4]
end if

push pdword [pebp+psize*2]      ;lsess
push pesi                       ;internal lsess
call CreateInternalClientSessionFromInternalListenStructure
mov pesi,peax

push pdword [pebp+psize*2]      ;lsess
call copyListenSessionToClientSession
xchg pesi,peax                  ;xchange internal Clientsession with external clientsession

;Add the internal Listen Structure to the listed, indexed on the ExternalListenSession
push peax             ;Item   (internal sess)
push pesi             ;Index  (public sess)
push [clientSessions] ;Collection
call AddIndexedDwordItem ;AddIndexedItem
xor eax,eax ;Clear Item ID

if used is64 & used isLin
  push pedx
  mov pedx,pdword [pebp+psize*2]
  call denter

  xchg pesi,pedx
  ;argpush 3,pesi                       ;sess
  ;argpush 2,pedx                       ;lsess
else
  argpush 3,pesi                       ;sess
  argpush 2,pdword [pebp+psize*2]      ;lsess
end if

;Make call to StartListening
argpush 1,pebx                       ;psess
if used is32
  call pdword [pedi+(psize*(2+StartListening))]
else
  call pdword [r12+(psize*(2+StartListening))]
end if

if used is64 & used isLin
  call dleave
  pop pedx
end if

test eax,eax
jz errStartListening

push pesi
ppush StartClientSession
call createthread

;argpush 1,pesi
;call StartClientSession


;lea peax,dword [StartClientSession]
;argpush 1,pesi                ;lsess (param)
;call peax                ;baseAddress
;
jmp recallStartListening

errStartListening:

;Remove the internal and external client session that was created for the StartListening function that returned false
push pesi                  ;name (sess)
push [clientSessions]      ;collection
call RemoveDwordByIndex

push peax
call FreeInternalClientStructure

push pesi
call FreeClientSession

errGetInternalProtocolStructure:
;lock list for write actions whiule we collect the clientsessions binded to this litensession
push [clientSessions]      ;collection
call LockListWriteAcces

mov pedx,pdword [clientSessions] ;(R/E)DX = pointer to clientsession
mov pesi,pdword [pebp+psize*2]    ;(R/E)SI = pointer to external ListenSession

push pedx   ;collection
call CountItems
mov ecx,eax ;ECX = ammount of items
xor ebx,ebx ;EBX = 0 (will be used to count the pushed ClientSessions on stack
test pecx,pecx
jz waitForClientSessions
;jecxz waitForClientSessions
shr ecx,1   ;ECX = ECX / 2

collectClientSessions:
  mov eax,ecx ;EAX = current index
  shl eax,1   ;EAX = EAX * 2

  ;Get the InternalClientSession structure
  push peax   ;itemId
  push pedx  ;List clientSessions
  call GetDwordItem
  test peax,peax
  jz nextCollectClientSessions

  ;Is this clientsession binded to our listensession
  cmp pdword [peax+psize],pesi
  jne nextCollectClientSessions

  ;This clientsession is binded to this listensession
  mov eax,ecx ;EAX = current index
  shl eax,1   ;EAX = EAX * 2
  dec eax     ;EAX = itemId of the index in the list

  ;Get the ClientSession structure
  push peax   ;itemId
  push pedx  ;List clientSessions
  call GetDwordItem
  test peax,peax
  jz nextCollectClientSessions

  ;push listensession on stack and inrement ebx
  push peax
  inc ebx

nextCollectClientSessions:
loop collectClientSessions

waitForClientSessions:
  ;unlock the clientsessions list
  push pedx  ;List clientSessions
  call ExternalUnlockListWriteAcces

  ;wait a second before checking if the clientsessions are still active
  push 1000
  call sleep

  ;lock list for write actions whiule we collect the clientsessions binded to this litensession
  push pedx  ;List clientSessions
  call LockListWriteAcces

  mov ecx,ebx ;ECX = ammount
  jecxz endNextCollectClientSessions

  checkClientSessions:
    mov edi,ecx ;current item
    dec edi     ;EDI--;
    if used is32
      shl pedi,2  ;(R/E)DI = (R/E)DI*4
    else
      shl pedi,3  ;(R/E)DI = (R/E)DI*8
    end if

    mov peax,pdword [pesp+pedi]  ;get clientsession from stack

    push peax
    push pedx  ;List clientSessions
    call GetIndexedDwordItem
    test peax,peax
    jz zeroClientSession ;Zero the clientsession on stack, since it does not exists annymore

    ;Is this clientsession binded to our listensession
    cmp pdword [peax+psize],pesi
    je waitForClientSessions ;The clientsession still exist, keep waiting
    jmp nextCheckClientSessions

  zeroClientSession:
    mov pdword [pesp+pedi],0 ;zero the clientsession, since it does not exists annymore

  nextCheckClientSessions:
  loop checkClientSessions
endNextCollectClientSessions:

;Ok, all the clientsession binded to this listensession shut down, now we can delete the listensession
if used is32
  shl pebx,2  ;(R/E)BX = (R/E)BX*4
else
  shl pebx,3  ;(R/E)BX = (R/E)BX*8
end if

add pesp,pebx ;clear the pushed clientsession on stack

;unlock the clientsessions list
push pedx  ;List clientSessions
call ExternalUnlockListWriteAcces

;find internal ListenSession
push pesi                  ;name (lsess)
push [listenSessions]      ;collection
call GetIndexedDwordItem
mov pedx,pdword [peax]     ;BindedTohandle list

push pedx
call CountItems
mov pecx,peax

;call CloseListenSession of every protocol
callCloseListenSessionLoop:
  ;get psess of binded protocol
  push pecx
  push pedx
  call GetDwordItem
  mov pebx,peax              ;set psess on (R/E)BX

  ;get internal protocol session
  push peax
  call getInternalProtocolStructure
  test eax,eax
  jz nextCallCloseListenSessionLoop

  ;get modstruct
  if used is32
    mov pedi,pdword [peax+psize*4]
  else
    mov r12,pdword [peax+psize*4]
  end if

  call denter  ;this will corrupt EAX and save all other registers
  MakeStack


  if used is32
    cmp pdword [pedi+(psize*(2+CloseListenSession))],0
  else
    cmp pdword [r12+(psize*(2+CloseListenSession))],0
  end if
  je notCallCloseListenSession

  argpush 2,pesi                       ;lsess
  argpush 1,pebx                       ;psess
  if used is32
    call pdword [pedi+(psize*(2+CloseListenSession))]
  else
    call pdword [r12+(psize*(2+CloseListenSession))]
  end if


notCallCloseListenSession:
  call dleave  ;retore all registers (except EAX)
nextCallCloseListenSessionLoop:
loop callCloseListenSessionLoop

if used is64 & used isWin
  fixStack 0    ;align stack on 0x10  (win x64 calling convention)
  sub pesp,0x10 ;create shadow places for the function call (for windows x64)
end if

;call the registerd ListenSessionIsCreated functions
push [registerdListenSessionIsCreatedFunctions]
call CountItems
mov ecx,eax

jecxz endLoopListenSessionIsCreatedCallbackFunctions2 ;jump when there are no callback functions registerd

loopListenSessionIsCreatedCallbackFunctions2:
  push pecx
  push [registerdListenSessionIsCreatedFunctions]
  call GetDwordItem
  test peax,peax
  jz endLoopListenSessionIsCreatedCallbackFunctions2

  mov pebx,pecx ;save ecx

  if used is64 & used isLin
    mov r12,rax
    call denter
        
    argpush 1,pesi ;lsess
    argpush 2,LCCF_LSESS_UNLOADED ;LCCF_LSESS_UNLOADED flag
    call r12 ;call ListenSessionIsCreated Callback Function

     call dleave
  else
    argpush 2,LCCF_LSESS_UNLOADED ;LCCF_LSESS_UNLOADED flag
    argpush 1,pesi ;lsess
    call peax ;call ListenSessionIsCreated Callback Function
  end if

  mov pecx,pebx ;restore ecx

nextLoopListenSessionIsCreatedCallbackFunctions2:
  loop loopListenSessionIsCreatedCallbackFunctions2
endLoopListenSessionIsCreatedCallbackFunctions2:

;finaly, remove the listensession and quit :)
push pesi                   ;name (lsess)
push [listenSessions]      ;collection
call RemoveDwordByIndex
push peax
call FreeInternalListenStructure

push pesi
call FreeListenSession

endcallStartListening:
call dleave
EndProc 1
endCreatedThread
ret (FunctionReturnFactor*1)

;------------------------------------------------------------------------------
;The CloseClientSession function should shutdown the connection with the Client
;------------------------------------------------------------------------------
;---------
;C implementation
;---------
if used is64
    CloseListenSession_c:
    StartProc 2

    mov rcx,retCloseListenSession_c
    xchg qword [rsp],rcx
    jmp CloseListenSession_asm

    retCloseListenSession_c:
    sub rsp,2*psize
    EndProc 2
    jmp rcx
else
    CloseListenSession_c:
end if
;---------
;asm implementation
;---------
CloseListenSession_asm:
push pdword [pesp] ;push return pointer
mov peax,pdword [pesp+psize*2] ;psess
mov pdword [pesp+psize*1],peax
mov peax,pdword [pesp+psize*3] ;lsess
mov pdword [pesp+psize*2],peax

mov pdword [pesp+psize*3],CLS_REMOVE_LISTENSESSION_FROM_SETTINGS ;flags
jmp CloseListenSessionEx_asm


;------------------------------------------------------------------------------
;The CloseClientSessionEx function will stop ListenSesion and it's clients, and optionaly delete settings
;------------------------------------------------------------------------------
;---------
;Internal call, skip protocolsession check
;---------
CloseListenSessionEx_internal:
jmp CloseListenSessionEx_internal_jump

;---------
;C implementation
;---------
if used is64
    CloseListenSessionEx_c:
    StartProc 3

    mov rcx,retCloseListenSessionEx_c
    xchg qword [rsp],rcx
    jmp CloseListenSessionEx_asm

    retCloseListenSessionEx_c:
    sub rsp,3*psize
    EndProc 3
    jmp rcx
else
    CloseListenSessionEx_c:
end if
;---------
;asm implementation
;---------
CloseListenSessionEx_asm:
;check on internal flag
test dword [pesp+psize*3],CLS_INTERNAL_SKIP_PROTOCOLSESSION_CHECK
jz CloseListenSessionEx_internal_jump

;remove on internal flag
xor dword [pesp+psize*3],CLS_INTERNAL_SKIP_PROTOCOLSESSION_CHECK

;Jump here internaly to support the internal flags
CloseListenSessionEx_internal_jump:
call denter
MakeStack

test dword [pebp+(psize*4)],CLS_INTERNAL_SKIP_PROTOCOLSESSION_CHECK
jnz skipProtocolCheck
;check if Protocolsession and ClientSession are valid
mov pecx,errCloseListenSession
call checkProtocolSession

skipProtocolCheck:
mov pecx,errCloseListenSession
call checkListenSession

test pdword [pebp+(psize*4)],CLS_REMOVE_LISTENSESSION_FROM_SETTINGS
jz dontRemoveListenSessionFromSettings

push peax ;save internal listensession

plog LOG_MESSAGE,"Removing listensession '",0x11,pdword [peax+(psize*5)+4+4+psize],"' from disk."
;remove listensession from disk
push peax
call RemoveListenSessionToDisk

pop peax;restore internal listensession

dontRemoveListenSessionFromSettings:
mov pesi,pdword [peax+(psize*5)+4+4+psize] ;*name for logging purposes
mov peax,pdword [peax] ;Get BindedTohandle from the InternalListenStructure
;Get first psess of the BindedTohandle structure (=>Receiver protocol)
push 1
push peax
call GetDwordItem
mov pebx,peax ;(R/E)BX => Get first psess of the BindedTohandle structure (=>Receiver protocol)

;Get the internal protocol structure of the psess value
push pebx
call getInternalProtocolStructure
test peax,peax
jz errCloseListenSession

mov peax,pdword [peax+psize*4] ;Get modstruct of Internal ProtocolStructure

plog LOG_MESSAGE,"Stopping listensession ",0x11,pesi,"..."

  if used is64 & used isLin
    mov r12,peax
    mov r13,pdword [pebp+psize*3]  ;sess
    call denter

    argpush 2,r13      ;sess
  else
    argpush 2,pdword [pebp+psize*3]      ;sess
  end if

;call PrepareCloseListenSession
argpush 1,pebx                       ;psess
if used is64 & used isLin
  call pdword [r12+(psize*(2+PrepareCloseListenSession))]
else
  call pdword [peax+(psize*(2+PrepareCloseListenSession))]
end if

ClearStackAftherCall 2
  if used is64 & used isLin
    call dleave
  end if

push [clientSessions]
call CountItems
mov ecx,eax
test eax,eax
jz errCloseListenSession

closeAllClientSessions:
  rcr ecx,1 ;check first bit for even/uneven
  jnc nextCloseClientSession  ;jump if even (even items are Internal ClientSession)
  rcl ecx,1

  ;Get ClientSession from list
  push pecx
  push [clientSessions]
  call GetDwordItem
  test peax,peax
  jz nextCallInternalCloseClientSession

  mov pedx,pesp ;save (R/E)SP
  ;push arguments for CloseClientSession
  push peax ;ClientSession

  ;Check if this ClientSession belongs to this ListenSession
  push peax ;ClientSession
  push pebx ;Protocolsession
  call GetListenSessionFromClientSession_internal
  cmp peax,pdword [pebp+psize*3]
  cmovnz pesp,pedx ;restore stack if the ClientSession doesn not belong to this ListenSession
  jnz nextCallInternalCloseClientSession

  push pebx ;protocol session
  ;--test dword [pebp+(psize*4)],CLS_INTERNAL_SKIP_PROTOCOLSESSION_CHECK
  ;--jnz callInternalCloseClientSession
  call CloseClientSession_asm
  jmp nextCallInternalCloseClientSession

  ;callInternalCloseClientSession:
  ;call CloseClientSession_internal

  nextCallInternalCloseClientSession:
  rcr ecx,1

nextCloseClientSession:
  rcl ecx,1
loop closeAllClientSessions

errCloseListenSession:
call dleave
ret psize*3