
;TV's server version 3.20
;Copyright (c) 2014 - 2022, Tycho Veltmeijer.
;All rights reserved.

;------------------------------------------------------------------------------
;This function is called to exchange the export table of this plugin and receive
;------------------------------------------------------------------------------
;---------
;C implementation
;---------
if used is64 & used __asm_exchange_tables_c
    __asm_exchange_tables_c:
    StartProc 2

    mov rdx,rax ;save rax

    mov rcx,ret__asm_exchange_tables_c
    xchg qword [rsp],rcx
    jmp __asm_exchange_tables

    ret__asm_exchange_tables_c:
    sub rsp,2*psize
    EndProc 2
    mov rax,rdx ;restore rax
    jmp rcx
else
    __asm_exchange_tables_c:
end if

;---------
;ASM implementation
;---------
__asm_exchange_tables:
__asm_exchange_tables_asm:
call denter

mov dword [import_list], endImportList - beginImportList

if used initHTTPProtocol
  push pdword [pebp+(psize*3)]
  push pdword [pebp+(psize*2)]
  call [__asm_exchange_tables_HTTP_PROTOCOL]
end if

mov peax,pdword [pebp+(psize*2)]

;reveive base export table
if used isLinux
  lea pecx,dword [import_list]
  push pecx
else
  ppush import_list
end if
call peax  ;__asm_get_export_table
test eax,eax
jz end___asm_exchange_tables

if used isNotPlugin
else
  ;Send our export table
  if used isLinux
    lea pecx,dword [export_list]
    push pecx
  else
    ppush export_list
  end if
  call [__asm_set_export_table]
end if

logmod LOG_MESSAGE,0,0,0,[mymod],"Succesfully exchanged export tables"

;return
end___asm_exchange_tables:
call dleave
ret (psize*2)


if used GetProtocolNames
;------------------------------------------------------------------------------
;The GetProtocolNames function needs to return a list of protocols it supports.
;------------------------------------------------------------------------------
GetProtocolNames:
StartProc 2 ;param len is not set on stack
call denter



;if used is64
;   mov rax,rdx  ;param len -- move the pointer len to register
;else
   mov peax,pdword [pebp+(psize*3)] ;param len -- move the pointer len to register
;end if

test peax,peax ;if len == 0
jz end_GetProtocolNames

mov ecx,dword [peax] ;get len from its pointer
cmp ecx,sizeSubportedProtocols
jae copyProtocols  ;jump if len>sizeSubportedProtocols

;place correct size in pointer len
mov dword [peax],sizeSubportedProtocols

;set return value to true
xor peax,peax
inc peax
jmp end_GetProtocolNames   ;return

copyProtocols:
mov peax,pdword [pebp+(psize*2)] ;move pointer buf to register

;copy the protocol names
ppush sizeSubportedProtocols
if used isLinux
  lea pecx,dword [subportedProtocols]
  push pecx
else
  ppush subportedProtocols
end if
push peax
call strcpyn

logmod LOG_MESSAGE,0,0,0,[mymod],"Succesfully copied the protocolnames to TV's server buffer."

;return
end_GetProtocolNames:
call dleave
EndProc 2
ret (FunctionReturnFactor*2)
end if