
;TV's server version 3.20
;Copyright (c) 2014 - 2022, Tycho Veltmeijer.
;All rights reserved.

;------------------------------------------------------------------------------
;This function will initialize the ClientSession (if TCP) and handle the connection (if HTTP)
;-------------------------     -----------------------------------------------------
HandleConnection:
StartProc 2 ;Set arguments on stack
call denter

retryhigherConnectedPeople:
  mov esi,0x1 ;GET_FROM_CLIENTSESSION
  mov eax,1
  call GetPluginDataInt ;(R/E)CX => maximum allowed connections

  ;Get ListenSession
  push pdword [pebp+psize*3]
  push pdword [pebp+psize*2]
  call [GetListenSessionFromClientSession]

  ;find the data member of this protocol
  push pdword [peax+8]       ;ProtocolData structure of ListenSession structure
  push pdword [pebp+psize*2]                  ;psess
  call [FindProtocolDataStruct]
  lea pesi,pdword [peax+psize*2] ;data (current ConnectedPeople)

  mov eax,dword [pesi] ;current connected people
  mov edx,eax
  inc edx     ;current connected people + 1

  cmp edx,ecx
  ja errHandleConnection ;To many connected people

  lock cmpxchg [pesi],edx
jnz retryhigherConnectedPeople

call dleave
call denter

mov pedx,pdword [pebp+psize*2]  ;psess
mov pecx,pdword [pebp+psize*3]  ;sess

;call the next HandleConnection function from the other protocols
push pecx       ;sess
push pedx       ;psess
call [CallNextHandleConnection]
push peax ;save returned value

;Get ListenSession
push pdword [pebp+psize*3]
push pdword [pebp+psize*2]
call [GetListenSessionFromClientSession]

push pdword [peax+8]       ;ProtocolData structure of ClientSession structure
push pdword [pebp+psize*2]                  ;psess
call [FindProtocolDataStruct]

lock dec dword [peax+psize*2]  ;decrement connected people\

pop peax ;restore return value

endHandleConnection:
call dleave
EndProc 2
ret (FunctionReturnFactor*2)

errHandleConnection:
xor eax,eax
inc eax
jmp endHandleConnection

;------------------------------------------------------------------------------
;This function will manipulate the received data
;------------------------------------------------------------------------------
RecvData_Man:
StartProc 6 ;Set arguments on stack
jmp [RecvData]

;------------------------------------------------------------------------------
;This function will manipulate the send data
;------------------------------------------------------------------------------
SendData_Man:
StartProc 6 ;Set arguments on stack
jmp [SendData]
