
;TV's server version 3.00
;Copyright (c) 2014, Tycho Veltmeijer.
;All rights reserved.

lin_syswrite equ 4
lin_sysexit equ 1
linsyscall equ int 0x80

moduleNameType equ 0x11

DIR_SEPERATOR equ '/'

SystemName equ 'Linux'
CPUname equ 'x86'
CPUArchitecture equ 'x86'

;32 BIT Equ's
ClearSpaceForAPI     equ 0
UsedSizeBydEnter     equ 0x14
FunctionReturnFactor equ 0
CallStackClearFactor equ 0x4
scasp equ scasd
movsp equ movsd
jpcxz equ jecxz
stosp equ stosd

psize       equ 4
pointer     equ dd
pdword      equ dword
peax        equ eax
pecx        equ ecx
pebx        equ ebx
pedx        equ edx
pedi        equ edi
pesi        equ esi
pebp        equ ebp
pesp        equ esp

;nonvolatile values
nvecx       equ ecx
nvedx       equ edx

;nonvolatile values
nvecxd       equ ecx
nvedxd       equ edx

;With this you can use the macro 'if used is32'
virtual at 0
call is32
is32:
end virtual


virtual at 0
call isLin
isLin:
end virtual

macro ClearStackAftherCall num
{ common
  add pesp,CallStackClearFactor*num
}

macro StartProc num
{ common
}

macro EndProc num
{ common
}

;macro ppush arg {
;  push peax
;  mov peax,arg
;  xchg pdword [pesp],peax
;}

;macro pmov arg1,arg2 {
;push peax
;mov peax,arg2
;mov arg1,peax
;pop peax
;}

macro ppush arg {
  push peax
  pop peax
  mov peax,arg
  xchg pdword [pesp-psize],peax
  sub pesp,psize
}

macro pmov arg1,arg2 {
  p2mov arg1,arg2,eax
}

macro p2mov arg1,arg2,useRegister {
if arg2 eq eax | arg2 eq ecx | arg2 eq rdx |arg2 eq esi | arg2 eq edi | arg2 eq edi | arg2 eq ebx
  mov arg1,arg2
else
  push useRegister
  add pesp,psize
  lea useRegister,pdword [arg2]
  mov arg1,useRegister
  mov useRegister,pdword [pesp-psize]
end if
}

macro argpush num,arg
{ common
  push arg
}

macro argpop num,arg
{ common
  pop arg
}

macro ClearStack
{ common

}

macro MakeStack
{ common

}

macro endCreatedThread
{ common
}

macro fixStack pushAnnyway
{ common
}

macro undoFixStack
{ common
}

if used denter
        denter:
        pop eax
        push edi
        push esi
        push ebx
        push edx
        push ecx
        push ebp

        mov ebp,esp
        add ebp,0x14
        jmp eax

end if

if used dleave
        dleave:
        pop ecx
        mov esp,ebp
        sub esp,0x14
        push ecx
        add esp,0x4
        pop ebp
        pop ecx
        pop edx
        pop ebx
        pop esi
        pop edi
        jmp dword [esp-0x1C]
end if

macro argpushsys num,arg
{ common
       if num = 1
          if arg eq ebx
          else
             mov ebx,arg
          end if
       else
          if num = 2
             if arg eq ecx
             else
                mov ecx,arg
             end if
          else
             if num = 3
                if arg eq edx
                else
                  mov edx,arg
                end if

             else
                if num = 4
                   if arg eq esi
                   else
                        mov esi,arg
                   end if
                 else
                    if num = 5
                       if arg eq edi
                       else
                            mov edi,arg
                       end if
                    else
                       if num = 6
                          if arg eq ebp
                          else
                                mov ebp,arg
                          end if
                       else
                            mov qword [rsp+((num-1)*8)],arg
                       end if
                    end if
                end if
             end if
           end if
       end if
}

macro linuxCall num,num32
{ common
  mov eax,num32
  int 0x80
}

macro alignStack {
}


if used saveVolatileRegister
macro saveVolatileRegister {
    push ecx
    push edx
}
end if

if used restoreVolatileRegister
macro restoreVolatileRegister {
    pop edx
    pop ecx
}
end if

macro lodsp {
   lodsd
}

macro stosp {
   stosd
}
