PROT_READ       equ 0x1
PROT_WRITE      equ 0x2
PROT_EXEC       equ 0x4
PROT_SEM        equ 0x8
PROT_NONE       equ 0x0
PROT_GROWSDOWN  equ 0x01000000
PROT_GROWSUP    equ 0x02000000

MAP_ANONYMOUS equ 0x20
MAP_GROWSDOWN equ 0x100
MAP_PRIVATE equ 0x2

RIGHT_READ equ 0x1
RIGHT_WRITE equ 0x2
RIGHT_EXECUTE equ 0x4

include "include/memfunctions_modes.inc"
include 'include/memfunctions.inc'

if used initGetSmallestPortionPageAllocation
  smallestPortionOfPageSize dd 0x1000-(psize*2)
  if used is64
    dd 0 ;make it compatible with qword :)
  end if
end if

if used decidePageSize
procDir db '/proc/'
pidStr db '                                                                                                 ',0

pageSize pointer 1024

decidePageSize:
call denter

linuxCall 39,20  ;getpid

push 10
ppush pidStr
push peax
call IntToStr

mov dword [peax-1],'/sma'
mov dword [peax-1+4],'ps'

push 0 ;read
ppush procDir ;path
call openFileHandle
cmp peax,-1
jz endDecidePageSize

mov pebx,peax ;R/EAX => file handle

inc peax ;add terminating zero byte
push peax
call GetMemLocation
mov pesi,peax ;R/ESI => mem location
mov pedx,peax ;P/EDX => original pointer to mem location


readNext:

  mov pecx,1024*1024*2 ;peax ;R/ECX size to read

  push pecx ;size
  push pesi ;buffer
  push pebx ;file decriptor
  call readfile
  test eax,eax
  jz endDecidePageSize_err

  push pebx
  call closefile

  findMMUPageSize:
    push pushMMUPageSize-MMUPageSizeStr
    call pushMMUPageSize

    MMUPageSizeStr  db 'MMUPageSize:'

    pushMMUPageSize:
    push pesi
    call comapairMem
    jz foundMMUPageSize

    inc pesi
  loop findMMUPageSize

  jmp endDecidePageSize_err


  foundMMUPageSize:
    add pesi,pushMMUPageSize-MMUPageSizeStr

  deleteSpaces:
    lodsb
    cmp al,' '
  je deleteSpaces

  dec pesi
  mov pecx,pesi


  findSpace:
    lodsb
    cmp al,' '
  jne findSpace

  dec pesi
  mov byte [pesi],0

  mov pesi,pecx

  push 10
  push pesi
  call StrToInt

  shl peax,10
  mov [pageSize],peax

mov pdword [errno],peax
call printError

endDecidePageSize_err:

  push pedx
  call FreeMemLocation

endDecidePageSize: ;???? error

call dleave
ret
end if

;------------------------------------------------------------------------------
;This will make a call to VirtualAlloc and VirtualQuery to determine the smallest
;peace of memory VirtualAlloc can allocate (useally ~4K). If Virtual Divider is
;it will also init the AllocatedMemory structure.
;input:
;  none
;output: unknown
;------------------------------------------------------------------------------
if used initGetSmallestPortionPageAllocation
  initGetSmallestPortionPageAllocation:

  if used New_Memory_management & ~ used MemoryMultiThreaded
    call initNewPointerList
    mov [AllocatedMemorys],peax
  end if

  endInitGetSmallestPortionPageAllocation:
  ret
end if

;------------------------------------------------------------------------------
;This sould be called when a new thread starts, a AllocatedMemory structure will
;be init and be placed on Stack, and pointer to stack will be placed on TEB.
;WARNING: Dont'forget to call uninitNewPointerListInTEB before exit the thread
;to clean up this structure from the stack!!

;INPUT:
;    NONE
;------------------------------------------------------------------------------
if used New_Memory_management & used MemoryMultiThreaded
  ;------------------------------------------------------------------------------
  ;Get UserReserved value (which is pointer to stack, created by initNewPointerListInTEB) from the TEB
  ;INPUT:
  ;    (R/A)EX: pointer from TEB to stack with AllocatedMemory structure
  ;------------------------------------------------------------------------------
  ;--set UserReserved from Teb
  if used GetUserReservedValueTeb
    GetUserReservedValueTeb:
    if used is64
      mov rax,qword [fs:-psize*20]
    else
      mov eax,dword [gs:-psize*20]
    end if
    ret
  end if

  ;------------------------------------------------------------------------------
  ;Set UserReserved pointer on TEB
  ;INPUT:
  ;    (R/A)EX: value that need to be placed on the TEB. (pointer to stack with AllocatedMemory structure)
  ;------------------------------------------------------------------------------
  if used SetUserReservedValueTeb
    SetUserReservedValueTeb:
    if used is64
      mov qword [fs:-psize*20],rax
    else
      mov dword [gs:-psize*20],eax
      ret
    end if
    ret
  end if
end if

;------------------------------------------------------------------------------
;This function will make a new memory location with the required size 1:mem size
;------------------------------------------------------------------------------
if used GetMemLocation | used GetMemLocationVirtual
  GetMemLocationVirtual:
  call denter
  noDenter_GetMemLocation2:

  mov peax,pdword [pebp+(psize*2)] ;size
  add peax,psize*2                   ;add space to save the aloacted size   (2 for alignment)

  ;align with 0x1000
  test peax,0xFFF
  jz sizeIsAligned

  shr peax,12
  inc peax
  shl peax,12
  mov pdword [pebp+(psize*2)],peax

  sizeIsAligned:

if used is32
  push pebp
end if

argpushsys 6,0 ;offset
argpushsys 5,-1 ;fd
argpushsys 4,MAP_PRIVATE or MAP_ANONYMOUS ;;flags  MAP_GROWSDOWN MAP_STACK
argpushsys 3,PROT_READ or PROT_WRITE ;IPPROTO_TCP or IPPROTO_UDP
argpushsys 2,peax ;length
argpushsys 1,0 ;addr
linuxCall 9,192  ;sys_mmap2

if used is32
  pop pebp
end if

;set size  (if changing this, renember to change function __exitThread from threadfunctions.inc as well
mov pesi,pdword [pebp+(psize*2)]
mov pdword [peax],pesi
add peax,psize*2

  call dleave
  ret (psize*1)
end if

;------------------------------------------------------------------------------
;This function will free a memory location 1:mem location
;------------------------------------------------------------------------------
if used FreeMemLocation | used FreeMemLocationVirtual
  FreeMemLocationVirtual:
  call denter

  mov  pedi,pdword [pebp+(psize*2)]
  sub pedi,psize*2

;UnsafeFreeMemLocation:

  argpushsys 2,pdword [pedi]
  argpushsys 1,pedi
  linuxCall 11,91  ;munmap

  NothingToFree:
  call dleave
  ret (psize*1)
end if

;------------------------------------------------------------------------------
;This function will check if the VM location exists and check the rights:
;int doesVMLocationExists(mem:void*, requiredRights:int)
;requiredRights can be:
;---RIGHT_READ 0x1
;---RIGHT_WRITE 0x2
;---RIGHT_EXECUTE 0x4
;------------------------------------------------------------------------------
if used doesVMLocationExists
   doesVMLocationExists:
   xor eax,eax
   xchg pdword [pesp+psize*2],peax ;swap requiredRights with *size
   xchg pdword [pesp+psize],peax   ;swap memlocation with requiredRights
   xchg pdword [pesp],peax         ;swap return address with memlocation
   push peax                       ;push return address

end if


;------------------------------------------------------------------------------
;This function will check if the VM location exists and check the rights:
;int doesVMLocationExistsEx(mem:void*, requiredRights:int, *size:int)
;requiredRights can be:
;---RIGHT_READ 0x1
;---RIGHT_WRITE 0x2
;---RIGHT_EXECUTE 0x4
;------------------------------------------------------------------------------
if used doesVMLocationExistsEx | used doesVMLocationExists
   doesVMLocationExistsEx:
   call denter

   mov peax,pdword [pebp+psize*2] ;*mem

   test peax,peax
   jz errdoesVMLocationExistsEx
;
;
;Need futher implementation to fully function.
;In the future it should read out /proc/xxxx/maps
;For now it's implemented as used. return the size
;The only thing it doesn't do it return if the memory pointer exist or not
;

  mov pecx,pdword [pebp+psize*4] ;*size
  jpcxz enddoesVMLocationExistsEx

    mov pedx,pdword [peax-psize*2]
    sub pedx,psize*2 ;minus the size value
    mov pdword [pecx],pedx
    jmp enddoesVMLocationExistsEx


  errdoesVMLocationExistsEx:
    xor eax,eax

  enddoesVMLocationExistsEx:
  call dleave
  ret psize*3
end if