
;TV's server version 3.20
;Copyright (c) 2014 - 2022, Tycho Veltmeijer.
;All rights reserved.

;
;Support for both: init.d and systemctl
;If systemctl is available, this is used, otherwhis init.d is used
;If you want to force one or the other, you can simply modify function checkSystemCtl
;return 1 for systemctl, 0 for init.d
;

;Functions :
;InstallService
;UninstallService
;StopService
;StopDeleteService
;SetServiceState
;startService
;CheckAndStartService
;service_main
;ServiceProc

SA_SIGINFO equ 4
SA_UNSUPPORTED equ 0x400
SA_EXPOSE_TAGBITS equ 0x800
SA_RESTORER equ 0x4000000

defaults db 'defaults',0
UpdateRCBin db '/usr/sbin/update-rc.d',0

shProg db '/bin/sh',0
initdPath db '/etc/init.d/',0
startServiceStr db 'start',0
stopService db 'stop',0
uninstallService db 'uninstall',0

systemctl db '/bin/systemctl',0
servicePath db '/etc/systemd/system/',0;'/run/systemd/system/',0
serviceExtension db '.service',0
checkSystemCtlHasRun db 0
isSystemCtl db 0

enable db 'enable',0
disable db 'disable',0



service_Script_part_1:
db '[Unit]',0x0A
db 'Description=',0

service_Script_part_2:
db 0x0A
db 'After = network.target remote-fs.target nss-lookup.target',0x0A
db 0x0A
db '[Service]',0x0A
db 'ExecStart = ',0

service_Script_part_3:
db 0x0A
db 'KillSignal = 2',0x0A
db 'User=root',0x0A
db 'SecureBits=keep-caps',0x0A
db 'AmbientCapabilities=CAP_NET_BIND_SERVICE',0x0A
;db 'CapabilityBoundingSet=CAP_SYSLOG CAP_IPC_LOCK',0x0A
db 0x0A
db '[Install]',0x0A
db 'WantedBy = multi-user.target',0x0A ,0


init_part_1:
db '#!/bin/sh',0x0A
db '### BEGIN INIT INFO',0x0A
db '# Provides:          ',0

init_part_2:
db 0x0A
db '# Required-Start:    $local_fs $network $named $time $syslog',0x0A
db '# Required-Stop:     $local_fs $network $named $time $syslog',0x0A
db '# Default-Start:     2 3 4 5',0x0A
db '# Default-Stop:      0 1 6',0x0A
db '# Description:       ',0

init_part_3:
db 0x0A
db '### END INIT INFO',0x0A
db 0x0A
db 'NAME="',0

init_part_4:
db '"',0x0A
db 'SCRIPT="$NAME ',0

init_part_5:
db '"',0x0A
db 'RUNAS=root',0x0A
db 0x0A
db 'PIDFILE=/var/run/',0

init_part_6:
db '.pid',0x0A
db 'LOGFILE=/var/log/',0

init_part_7:
db '.log',0x0A
db 0x0A
db 'start() {',0x0A
db '  if [ -f $PIDFILE ] && [ -s $PIDFILE ] && kill -0 $(cat $PIDFILE); then',0x0A
db "    echo 'Service already running' >&2",0x0A
db '    return 1',0x0A
db '  fi',0x0A
db "  echo 'Starting service...' >&2",0x0A
db '  local CMD="$SCRIPT &> \"$LOGFILE\" & echo \$!"',0x0A
db '  su -c "$CMD" $RUNAS > "$PIDFILE"',0x0A
db 0x0A
db '  sleep 2',0x0A
db '  PID=$(cat $PIDFILE)',0x0A
db '    if pgrep -u $RUNAS -f $NAME > /dev/null',0x0A
db '    then',0x0A
db '      echo "Service is now running, the PID is $PID"',0x0A
db '    else',0x0A
db "      echo ''",0x0A
db '      echo "Error! Could not start $NAME!"',0x0A
db '    fi',0x0A
db '}',0x0A
db 0x0A
db 'stop() {',0x0A
db '  if [ ! -f "$PIDFILE" ] || ! kill -0 $(cat "$PIDFILE"); then',0x0A
db "    echo 'Service not running' >&2",0x0A
db '    return 1',0x0A
db '  fi',0x0A
db "  echo 'Stopping service...' >&2",0x0A
db '  kill -s2 $(cat "$PIDFILE") && rm -f "$PIDFILE"',0x0A
db "  echo 'Service stopped' >&2",0x0A
db '}',0x0A
db 0x0A
db 'uninstall() {',0x0A
db '  echo -n "Are you really sure you want to uninstall this service? That cannot be undone. [yes|No] "',0x0A
db '  local SURE',0x0A
db '  read SURE',0x0A
db '  if [ "$SURE" = "yes" ]; then',0x0A
db '    stop',0x0A
db '    rm -f "$PIDFILE"',0x0A
db '    echo "Notice: log file was not removed: $LOGFILE" >&2',0x0A
db '    update-rc.d -f $NAME remove',0x0A
db '    rm -fv "$0"',0x0A
db '  else',0x0A
db '    echo "Abort!"',0x0A
db '  fi',0x0A
db '}',0x0A
db 0x0A
db 'status() {',0x0A
db '    printf "%-50s" "Checking service..."',0x0A
db '    if [ -f $PIDFILE ] && [ -s $PIDFILE ]; then',0x0A
db '        PID=$(cat $PIDFILE)',0x0A
db '            if [ -z "$(ps axf | grep ${PID} | grep -v grep)" ]; then',0x0A
db '                printf "%s\n" "The process appears to be dead but pidfile still exists"',0x0A
db '            else',0x0A
db '                echo "Running, the PID is $PID"',0x0A
db '            fi',0x0A
db '    else',0x0A
db '        printf "%s\n" "Service not running"',0x0A
db '    fi',0x0A
db '}',0x0A
db 0x0A
db 0x0A
db 'case "$1" in',0x0A
db '  start)',0x0A
db '    start',0x0A
db '    ;;',0x0A
db '  stop)',0x0A
db '    stop',0x0A
db '    ;;',0x0A
db '  status)',0x0A
db '    status',0x0A
db '    ;;',0x0A
db '  uninstall)',0x0A
db '    uninstall',0x0A
db '    ;;',0x0A
db '  restart)',0x0A
db '    stop',0x0A
db '    start',0x0A
db '    ;;',0x0A
db '  *)',0x0A
db '    echo "Usage: $0 {start|stop|status|restart|uninstall}"',0x0A
db 'esac',0x0A,0


if used dquote
  dquote db '\"',0
end if

if used service_name
service_name db ServiceName,0
end if

if used service_name_pointer
  service_name_pointer pointer service_name
end if



if used service_description
service_description_string db ServiceDescription,0

;SERVICE_DESCRIPTION structure
service_description:
pointer service_description_string
end if



if used Handle
Handle pointer 0
end if


;------------------------------------------------------------------------------
;This function will check if we can use systemctl or not
;input:
;   none
;output:
;    (R/E)AX=> Boolean, true is yes and false is no
;------------------------------------------------------------------------------
if used checkSystemCtl
checkSystemCtl:
cmp byte [checkSystemCtlHasRun],0
jne returnAnswer

  push 0
  ppush systemctl
  call openFileHandle

  inc peax
  test peax,peax
  jz systemCtlIsNotHere

    mov [isSystemCtl],1
    ;The quote doesn't need to be escaped for systemctl service script, only in init.d
    mov word [dquote],'"'

    dec peax
    push peax
    call closefile

  systemCtlIsNotHere:
  mov [checkSystemCtlHasRun],1

returnAnswer:
xor eax,eax
mov al,[isSystemCtl]
ret
end if

;------------------------------------------------------------------------------
;This function will install the service on Windows NT based systems
;input:
;   none
;output:
;    (R/E)AX=> Boolean, true on succes and false of failure
;------------------------------------------------------------------------------
if used InstallService
InstallService:
call denter

push 0
call GetModuleName
mov pebx,peax

call checkSystemCtl
test eax,eax
jz useInitDInstead

;
;systemctl is available, so let's use it!!!
;
push 0
ppush service_Script_part_3
push 0x11
call pushProgramArguments
ppush dquote
push 0x11 ;UTF-8 string
push pebx ;module name
push 0x11 ;UTF-8 string
ppush dquote
push 0x11 ;UTF-8 string
ppush service_Script_part_2
push 0x11
push pdword [service_description] ;description
push 0x11
ppush service_Script_part_1
push 0x11
push 0
push 0
call CreateOneStringUtf8
xchg pebx,peax ;R/EBX => content for service script

push peax
call FreeModuleName

push 0
ppush serviceExtension
push 0x11
push [service_name_pointer] ;servicename
push 0x11 or 0x4000000 or 0x8000000
ppush servicePath
push 0x11
push 0
push 0
call CreateOneStringUtf8
mov pecx,peax ;E/RCX => push filename for init script

call WriteInitOrServiceScript

push pebx
call FreeMemLocation

push pecx
call FreeMemLocation

;Create 'name.service'
push 0
ppush serviceExtension
push 0x11
push [service_name_pointer] ;servicename
push 0x11 or 0x4000000 or 0x8000000
push 0
push 0
call CreateOneStringUtf8
mov pecx,peax ;E/RCX => 'name.service'

plog LOG_MESSAGE,'The name is: "',0x11,peax,'", Original it was: "',0x11,[service_name_pointer],'"'

push 0
push pecx      ;'name.service'
ppush enable    ;enable
ppush systemctl ;systemctl app

push pesp
call ExecAndWait

add pesp,psize*3

test peax,peax
jnz serviceIsEnabled


  push pecx
  call FreeMemLocation
  jmp endInstallService

serviceIsEnabled:

push 0
push pecx            ;'name.service'
ppush startServiceStr ;start
ppush systemctl       ;systemctl app

push pesp
call ExecAndWait

add pesp,psize*3

push pecx
call FreeMemLocation

xor eax,eax
inc eax
jmp endInstallService

useInitDInstead:
;
;systemctl is not available, so we have to use init.d script
;

push pebx
call GetFilenameFromPath

push 0 ;last item for createOneString (UTF8)
ppush init_part_7
push 0x11
push [service_name_pointer]  ;logfile
push 0x11 or 0x2000000 ;UTTF-8 and escape string
ppush init_part_6
push 0x11
push [service_name_pointer]  ;pidfile
push 0x11 or 0x2000000 ;UTTF-8 and escape string
ppush init_part_5
push 0x11

  call pushProgramArguments

  ppush init_part_4
  push 0x11
  push pebx ;path to exe
  push 0x11 or 0x2000000 ;UTTF-8 and escape string as terminal string
  ppush init_part_3
  push 0x11
  push pdword [service_description] ;description
  push 0x11
  ppush init_part_2
  push 0x11
  push [service_name_pointer] ;servicename
  push 0x11
  ppush init_part_1
  push 0x11
  push 0
  push 0
  call CreateOneStringUtf8
  xchg pebx,peax ;R/EBX => content for init.d script

  push peax
  call FreeModuleName

  push 0
  push [service_name_pointer] ;servicename
  push 0x11 or 0x4000000 or 0x8000000
  ppush initdPath
  push 0x11
  push 0
  push 0
  call CreateOneStringUtf8
  mov pecx,peax ;E/RCX => push filename for init script

  call WriteInitOrServiceScript

  push pebx
  call FreeMemLocation

  push 0
  ppush defaults
  push [service_name_pointer] ;servicename
  ppush UpdateRCBin

  push pesp
  call ExecAndWait

  add pesp,psize*3

  test peax,peax
  jz endInstallService

  push 0
  ppush startServiceStr
  push pecx ;init serive script
  ppush shProg

  push pesp
  call ExecAndWait

  add pesp,psize*3

  push peax

    push pecx
    call FreeMemLocation

  pop peax

  test peax,peax
  jz endInstallService


xor eax,eax
inc eax ;return 1 since the function succeeded

endInstallService:
call dleave
ret
end if

;------------------------------------------------------------------------------
;This will write r/ebx to filepath r/ecx and will give the file execute rights then it will be closed
;input:
;   R/ECX =>path to file
;   R/EBX => pointer to UTF-8 string to be written to file R/ECX
;output:
;    none
;------------------------------------------------------------------------------
WriteInitOrServiceScript:
  push 0x1 or 0x2 or 0x40000 ;read, write, create and truncate file
  push pecx
  call openFileHandle
  mov pedx,peax  ;R/EDX => file handle to init.d script

  push pebx
  call strlen

  push peax ;size
  push pebx ;pointer
  push pedx ;file handle
  call writefile

  call denter
  argpushsys 2,S_IRUSR or S_IWUSR or S_IXUSR or S_IRGRP or S_IWGRP or S_IXGRP or S_IROTH
  argpushsys 1,pedx ;file handle
  linuxCall 91,94  ;fchmod
  call dleave

  push pedx
  call closefile
ret

;------------------------------------------------------------------------------
;This will push all the arguments for this program on stack to be used with CreateOneStringx
;input:
;   none
;output:
;    R/EAX => pointer to the return address
;------------------------------------------------------------------------------
pushProgramArguments:
pop peax
cmp [log_options],0
je noLogOptionSwitch

  ppush dquote
  push 0x11 ;UTF-8 string

  push [log_options]
  push 0x11 ;UTF-8 string

  ppush dquote
  push 0x11 ;UTF-8 string

  call pushLogOptionSwitch

    db ' -o ',0

  pushLogOptionSwitch:
  push 0x11 ;UTF-8 string

noLogOptionSwitch:
cmp [log_location],0
je noLogfileName

  ppush dquote
  push 0x11 ;UTF-8 string

  push [log_location]
  push 0x11 ;UTF-8 string

  ppush dquote
  push 0x11 ;UTF-8 string

  call pushLogfileNameSwitch

    db ' -l ',0

  pushLogfileNameSwitch:
  push 0x11 ;UTF-8 string

noLogfileName:

push peax
mov peax,service_name
cmp [service_name_pointer],peax
pop peax
je noSpecialServiceName

  ppush dquote
  push 0x11 ;UTF-8 string

  push [service_name_pointer]
  push 0x11 ;UTF-8 string

  ppush dquote
  push 0x11 ;UTF-8 string

  call pushServiceNameSwitch

    db ' -n ',0

  pushServiceNameSwitch:
  push 0x1 ;UTF-8 string

noSpecialServiceName:

cmp [keyPointer],0
je noSpecialKey

  ppush dquote
  push 0x11 ;UTF-8 string

  push [keyPointer]
  push 0x11 ;UTF-8 string

  ppush dquote
  push 0x11 ;UTF-8 string

  call pushKeyNameSwitch

    db ' -r ',0

  pushKeyNameSwitch:
  push 0x11 ;UTF-8 string

noSpecialKey:
jmp peax

;------------------------------------------------------------------------------
;This function will uninstall the service on Windows NT-based systems
;input:
;   none
;output:
;    (R/E)AX=> Boolean, true on succes and false of failure
;------------------------------------------------------------------------------
if used UninstallService
UninstallService:

push 1
call StopDeleteService

endUninstallService:
ret
end if

;------------------------------------------------------------------------------
;This function will stop the service if running on Windows NT-based systems
;input:
;   none
;output:
;    (R/E)AX=> Boolean, true on succes and false of failure
;------------------------------------------------------------------------------
if used StopService
StopService:
push 0
call StopDeleteService
ret
end if

;------------------------------------------------------------------------------
;This function will stop the service if running and uninstall if the uninstall flag is set on Windows NT-based systems
;input:
;   1:flags:
;       0x0 STOP_SERVICE
;       0x1 STOP_AND_DELETE_SERVICE
;       0x2 START_SERVICE
;output:
;    (R/E)AX=> Boolean, true on succes and false of failure
;------------------------------------------------------------------------------
if used StopDeleteService | used StartStopDeleteService
StartStopDeleteService:
StopDeleteService:
call denter

call checkSystemCtl
test eax,eax
jz useInitDInstead2

;
;systemctl is available, so let's use it!!!
;

;Create 'name.service'
push 0
ppush serviceExtension
push 0x11
push [service_name_pointer] ;servicename
push 0x11 or 0x4000000 or 0x8000000
push 0
push 0
call CreateOneStringUtf8
mov pecx,peax ;E/RCX => 'name.service'

push 0
push pecx      ;'name.service'
ppush disable   ;disable
ppush systemctl ;systemctl app

test pdword [pebp+psize*2],0x1
jnz mustBeUninstalledOrStart2

  ;must only be stopped
  pmov pdword [pesp+psize],stopService

mustBeUninstalledOrStart2:
test pdword [pebp+psize*2],0x2
jz executeStopDeleteStartProgram

  ;must only be stopped
  pmov pdword [pesp+psize],startServiceStr
  jmp executeStopDeleteStartProgram

useInitDInstead2:
;
;systemctl is not available, so we have to use init.d script
;

push 0
push [service_name_pointer] ;servicename
push 0x11 or 0x4000000 or 0x8000000
ppush initdPath
push 0x11
push 0
push 0
call CreateOneStringUtf8
mov pecx,peax ;E/RCX => push filename for init script

push 0
ppush uninstallService
push pecx ;servicename
ppush shProg

test pdword [pebp+psize*2],0x1
jnz mustBeUninstalledOrStart

  ;must only be stopped
  pmov pdword [pesp+psize*2],stopService

mustBeUninstalledOrStart:
test pdword [pebp+psize*2],0x2
jz mustBeUninstalled

  ;must only be stopped
  pmov pdword [pesp+psize*2],startServiceStr

mustBeUninstalled:

executeStopDeleteStartProgram:
push pesp
call ExecAndWait

add pesp,psize*3

push peax

  push pecx
  call FreeMemLocation

pop peax

endStopDeleteService:
call dleave
ret psize
end if

;------------------------------------------------------------------------------
;This function will set the status of the service (that this process is currently running)
;input:
;   1:New status
;output:
;    (R/E)AX=> boolean: true if succeed
;
;New status:
;       0x1 SERVICE_STOPPED The service is not running.
;       0x2 SERVICE_START_PENDING The service is starting.
;       0x3 SERVICE_STOP_PENDING The service is stopping.
;       0x4 SERVICE_RUNNING The service is running.
;       0x5 SERVICE_CONTINUE_PENDING The service continue is pending.
;       0x6 SERVICE_PAUSE_PENDING The service pause is pending.
;       0x7 SERVICE_PAUSED The service is paused.
;------------------------------------------------------------------------------
if used SetServiceState
SetServiceState:

ret psize
end if

;------------------------------------------------------------------------------
;This function will try to boot the service
;input:
;   none
;output:
;    (R/E)AX=>  boolean, true if succeed, else false
;------------------------------------------------------------------------------
if used startService
startService:

push 0x2
call StartStopDeleteService

endStartService:
ret
end if

;------------------------------------------------------------------------------
;This function will register signal handlers to be able to stop all the services gradually
;input:
;   none
;output:
;    none
;------------------------------------------------------------------------------
if used registerSignalHandlers
registerSignalHandlers:
call denter

if used is32
  push 0           ;sigset_t
end if
push 0           ;sigset_t
ppush restorer  ;sa_restorer
push SA_SIGINFO or SA_RESTORER ;or SA_UNSUPPORTED or SA_EXPOSE_TAGBITS    ;sa_flags
ppush sig_handler ;sa_handler
mov pecx,pesp

argpushsys 4,8     ;size of(sigset_t)
argpushsys 3,0     ;oldact
argpushsys 2,pecx  ;sigaction
argpushsys 1,2     ;SIGINT
linuxCall 13,174   ;rt_sigaction

call dleave
ret
end if

;------------------------------------------------------------------------------
;This function will be called when a stop signal is received
;input:
;   1: int signal
;   2: siginfo_t info
;   3: void *ucontext
;output:
;    none
;------------------------------------------------------------------------------
sig_handler:

if used LOG
  sub pesp,0x60 ;make space for the 'Date' string

  ;get string with the date
  push pesp
  call GetGMTTime
  mov pecx,pesp
end if

;plog LOG_MESSAGE, "Received stop signal at ",0x1, pecx
if used LOG
  add pesp,0x60
end if

log LOG_MESSAGE, "Signal listensessions to stop ..."

call ShutdownServer_internal

mov eax,1
ret


;------------------------------------------------------------------------------
;Restorer, needed for the signal handler
;------------------------------------------------------------------------------
restorer:
linuxCall 15,173   ;rt_sigaction

;------------------------------------------------------------------------------
;This function will check if the executable should behave as service, and if so, start the service dispatcher
;input:
;   none
;output:
;    (R/E)AX=> boolean, false if the executable is running as service and true if not.
;------------------------------------------------------------------------------
if used CheckAndStartService
CheckAndStartService:
call denter

linuxCall 110,64  ;getppid
cmp eax,1
je alreadyRunningAsDaemon

call startService

xor eax,eax
inc eax

call dleave
ret

linuxCall 57,2  ;fork
test peax,peax
jl errorForking
jnz ThisIscurrentProcess

  linuxCall 112,66  ;setsid

  linuxCall 57,2  ;fork
  test peax,peax
  jl ThisIscurrentProcess
  jnz ThisIscurrentProcess

    push 0 ;stdin
    call closefile

    push 0x1 ;read and write
    call pushNullFileName

      db '/dev/null',0

    pushNullFileName:
    call openFileHandle
    test peax,peax
    jnz errCreatingDaemon

      argpushsys 2, 1 ;stdout
      argpushsys 1, 0 ;stdin
      linuxCall 33,63  ;dup2

      argpushsys 2, 2 ;stderr
      argpushsys 1, 0 ;stdin
      linuxCall 33,63  ;dup2

      alreadyRunningAsDaemon:
      xor eax,eax ;also returning zero, only windows shoudl return 1

      call dleave
      ret

endCheckAndStartService:

errCreatingDaemon:
ThisIscurrentProcess:
push 0
call exitProcess

errorForking:
xor eax,eax
call dleave
ret
end if